package com.livro.capitulo3.crudannotations;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.livro.capitulo3.conexao.HibernateUtil;


public class ContatoCrudAnnotations{

	Session sessao = null;
	Transaction transaction = null;
	Query consulta = null;
	List<ContatoAnnotations> resultado = null;
	ContatoAnnotations contatoUnico = null;

	public void salvar(ContatoAnnotations c){		
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.save(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}

	public void atualizar(ContatoAnnotations c){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.update(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}


	public void excuir(ContatoAnnotations c){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.delete(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}


	@SuppressWarnings("unchecked")
	public List<ContatoAnnotations> listar(){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			consulta = sessao.createQuery("from Contato");
			resultado = consulta.list();
			transaction.commit();
			
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}

		return resultado;
	}


	public ContatoAnnotations buscar(int id){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			consulta = sessao.createQuery("from Contato where codigo = :parametro");
			consulta.setInteger("parametro", id);
			contatoUnico = (ContatoAnnotations) consulta.uniqueResult();
			transaction.commit();
			
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
		return contatoUnico;
	}

}