package com.livro.capitulo3.crudxml;

import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.livro.capitulo3.conexao.HibernateUtil;


public class ContatoCrudXML{

	Session sessao = null;
	Transaction transaction = null;
	Query consulta = null;
	List<Contato> resultado = null;
	Contato contatoUnico = null;

	public void salvar(Contato c){		
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.save(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}

	public void atualizar(Contato c){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.update(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}


	public void excuir(Contato c){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.delete(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}


	@SuppressWarnings("unchecked")
	public List<Contato> listar(){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			consulta = sessao.createQuery("from Contato");
			resultado = consulta.list();
			transaction.commit();
			
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}

		return resultado;
	}


	public Contato buscar(int id){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			consulta = sessao.createQuery("from Contato where codigo = :parametro");
			consulta.setInteger("parametro", id);
			contatoUnico = (Contato) consulta.uniqueResult();
			transaction.commit();
			
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
		return contatoUnico;
	}


}