import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;


public class ContatoDAO{

	public void salvar(Contato c){
		Connection conexao = ConectaMysql.getInstance();
		PreparedStatement insereST = null;
		String sql = "insert into contato(nome, telefone, email, dt_cad, obs) values(?, ?, ?, ?, ?)";	

		try{
			insereST = conexao.prepareStatement(sql);
			insereST.setString(1, c.getNome());
			insereST.setString(2, c.getTelefone());
			insereST.setString(3, c.getEmail());
			insereST.setDate(4, c.getDataCadastro());
			insereST.setString(5, c.getObservacao());
			insereST.executeUpdate();
			System.out.println("Inserido com sucesso");
		}catch(SQLException e){
			System.out.println(e.getMessage());
		}finally{
			try{
				insereST.close();
			}catch(Throwable e){
				System.out.println(e.getMessage());
			}
		}
	}

	public List<Contato> listar(){
		Connection conexao = ConectaMysql.getInstance();
		List<Contato> contatos = new ArrayList<Contato>();
		Statement consulta = null;
		ResultSet resultado = null;
		Contato contato = null;
		String sql = "select * from contato";	
		try{
			consulta = conexao.createStatement();
			resultado = consulta.executeQuery(sql);
			while(resultado.next()){
				contato = new Contato();
				contato.setCodigo(resultado.getInt("codigo"));
				contato.setNome(resultado.getString("nome"));
				contato.setTelefone(resultado.getString("telefone"));
				contato.setEmail(resultado.getString("email"));
				contato.setDataCadastro(resultado.getDate("dt_cad"));
				contato.setObservacao(resultado.getString("obs"));
				contatos.add(contato);
			}
		}catch(SQLException e){
			System.out.println(e.getMessage());
		}finally{
			try{
				consulta.close();
				resultado.close();
				conexao.close();
			}catch(Throwable e){
				System.out.println(e.getMessage());
			}
		}
		return contatos; 
	}




	public static void main(String[] args) {
	
	}

}