import java.sql.Date;
import java.util.List;
import org.hibernate.Session;
import org.hibernate.HibernateException;
import org.hibernate.Transaction;
import org.hibernate.Query;


public class ContatoDAOXML{

	Session sessao = null;
	Transaction transaction = null;
	Query consulta = null;
	List<Contato> resultado = null;
	Contato contatoUnico = null;

	public void salvar(Contato c){		
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.save(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}

	public void atualizar(Contato c){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.update(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}


	public void excuir(Contato c){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			sessao.delete(c);
			transaction.commit();
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
	}


	public List<Contato> listar(){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			consulta = sessao.createQuery("from Contato");
			resultado = consulta.list();
			transaction.commit();
			
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}

		return resultado;
	}


	public Contato buscar(int id){
		try{
			sessao = HibernateUtil.getSessionFactory().openSession();
			transaction  = sessao.beginTransaction();
			consulta = sessao.createQuery("from Contato where codigo = :parametro");
			consulta.setInteger("parametro", id);
			contatoUnico = (Contato) consulta.uniqueResult();
			transaction.commit();
			
		}catch(HibernateException e){
			e.printStackTrace();
		}finally{
			try{
				sessao.close();
			}catch(Throwable e){
				e.printStackTrace();
			}
		}
		return contatoUnico;
	}

	public static void main(String[] args) {
		ContatoDAOXML contatoDAOXML = new ContatoDAOXML();
		String[] nomes = {"Fulano", "Beltrano", "Ciclano"};
		String[] fones = {"(47) 2222-1111", "(47) 7777-5555", "(47) 9090-2525"};
		String[] emails = {"fulano@teste.com.br", "beltrano@teste.com.br", "ciclano@teste.com.br"};
		String[] observacoes = {"Novo cliente", "Cliente em dia", "Ligar na quinta"};
		Contato contato = null;
		
		for (int i = 0; i < nomes.length; i++) {
			contato = new Contato();
			contato.setNome(nomes[i]);
			contato.setTelefone(fones[i]);
			contato.setEmail(emails[i]);
			contato.setDataCadastro(new Date(System.currentTimeMillis()));
			contato.setObservacao(observacoes[i]);
			contatoDAOXML.salvar(contato);
		}
		System.out.println("Total de registros cadastrados: " + contatoDAOXML.listar().size());
		System.out.println("Busca: " + contatoDAOXML.buscar(2).getNome());
	}


}