package financeiro.usuario;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;

public class UsuarioDAOHibernate implements UsuarioDAO{

	private Session sessao;
	
	public void setSessao(Session sessao) {
		this.sessao = sessao;
	}
	
	@Override
	public void salvar(Usuario u) {
		this.sessao.save(u);
	}

	@Override
	public void atualizar(Usuario u) {
		if (u.getPermissao() == null || u.getPermissao().size() == 0) {
			Usuario uPermissao = this.carregar(u.getCodigo());
			u.setPermissao(uPermissao.getPermissao());
			this.sessao.evict(uPermissao);
		}
		this.sessao.update(u);
	}

	@Override
	public void excluir(Usuario u) {
		this.sessao.delete(u);
	}

	@Override
	public Usuario carregar(Integer id) {
		return (Usuario) this.sessao.get(Usuario.class, id);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<Usuario> listar() {
		return this.sessao.createCriteria(Usuario.class).list();
	}
	
	@Override
	public Usuario buscarPorLogin(String login) {
		String hql = "select u from Usuario where u.login = :login";
		Query consulta = this.sessao.createQuery(hql);
		consulta.setParameter("login", login);
		return (Usuario) consulta.uniqueResult();
	}

}
