package financeiro.web;

import java.util.List;
import java.util.Set;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;

import financeiro.conta.Conta;
import financeiro.conta.ContaRN;
import financeiro.usuario.Usuario;
import financeiro.usuario.UsuarioRN;

@ManagedBean(name="usuarioBean")
@RequestScoped
public class UsuarioBean {

	private Usuario usuario = new Usuario();
	private String confirmaSenha;
	private  List<Usuario> lista;
	private String destinoSalvar;
	private Conta conta  = new Conta();
	
	public String novo(){
		this.usuario = new Usuario();
		this.usuario.setAtivo(true);
		return "usuario";
	}
	
	public String editar(){
		this.confirmaSenha = this.usuario.getSenha();
		return "/publico/usuario";
	}
	
	public String atribuirPermissao(Usuario u, String p){
		this.usuario = u;
		Set<String> permissoes = this.usuario.getPermissao();
		if(permissoes.contains(p)){
			permissoes.remove(p);
		}else{
			permissoes.add(p);
		}
		
		return null;
	}
	
	public String salvar(){
		FacesContext facesContext = FacesContext.getCurrentInstance();
		
		String senha = this.usuario.getSenha();
		if(!senha.equals(this.confirmaSenha)){
			FacesMessage faceMessage = new FacesMessage("A senhas não conferem");
			facesContext.addMessage(null, faceMessage);
			return null;
		}
		
		UsuarioRN usuarioRN = new UsuarioRN();
		usuarioRN.salvar(this.usuario);
		
		if(this.conta.getDescricao() != null){
			this.conta.setUsuario(this.usuario);
			this.conta.setFavorita(true);
			ContaRN cRN = new ContaRN();
			cRN.salvar(this.conta);
			
		}
		
		
		return "/publico/usuarioSucesso";
	} 
	
	public String excluir() {
		UsuarioRN rn = new UsuarioRN();
		rn.excluir(this.usuario);
		this.lista = null;
		return null;
	}	
	
	public String setAtivar() {
		if(this.usuario.isAtivo()){
			this.usuario.setAtivo(false);
		}else{
			this.usuario.setAtivo(true);
		}
		UsuarioRN rn = new UsuarioRN();
		rn.salvar(this.usuario);
		return null;
	}
	
	public Usuario getUsuario() {
		return usuario;
	}
	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}
	public String getConfirmaSenha() {
		return confirmaSenha;
	}
	public Conta getConta() {
		return conta;
	}

	public void setConta(Conta conta) {
		this.conta = conta;
	}

	public void setLista(List<Usuario> lista) {
		this.lista = lista;
	}

	public void setConfirmaSenha(String confrimaSenha) {
		this.confirmaSenha = confrimaSenha;
	}

	public String getDestinoSalvar() {
		return destinoSalvar;
	}

	public void setDestinoSalvar(String destinoSalvar) {
		this.destinoSalvar = destinoSalvar;
	}

	public List<Usuario> getLista() {
		if(this.lista == null){
			UsuarioRN rn = new UsuarioRN();
			this.lista = rn.listar();
		}
		return lista;
	}
	
	
}
