package financeiro.usuario;

import java.util.List;

import financeiro.util.DAOFactory;

public class UsuarioRN {

	private UsuarioDAO usuarioDAO;

	public UsuarioRN() {
		this.usuarioDAO = DAOFactory.criaUsuarioDAO();
	}

	public Usuario buscarUsuarioId(Integer id) {
		return this.usuarioDAO.carregar(id);
	}


	public Usuario buscarUsuarioLogin(String login) {
		return this.usuarioDAO.buscarPorLogin(login);
	}

	public void salvar(Usuario u) {
		Integer id = u.getCodigo();
		if (id == null || id == 0) {
			u.getPermissao().add("ROLE_USUARIO");
			this.usuarioDAO.salvar(u);
		} else {
			this.usuarioDAO.atualizar(u);
		}
	}

	public void excluir(Usuario u) {
		this.usuarioDAO.excluir(u);
	}

	public List<Usuario> listar() {
		return this.usuarioDAO.listar();
	}

}
