package financeiro.web;

import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;

import financeiro.conta.Conta;
import financeiro.conta.ContaRN;
import financeiro.web.util.ContextoUtil;


@ManagedBean(name="contaBean")
@RequestScoped
public class ContaBean {

	
	private Conta selecionada = new Conta();
	private List<Conta> lista = null;
	
	public void salvar(){
		ContextoBean contextoBean = ContextoUtil.getContextoBean();
		this.selecionada.setUsuario(contextoBean.getUsuarioLogado());
		ContaRN contaRN = new ContaRN();
		contaRN.salvar(this.selecionada);
		this.selecionada = new Conta();
		this.lista = null;
	}
	
	
	
	public void editar(){
		
	}
	
	
	
	public void excluir(){
		ContaRN contaRN = new ContaRN();
		contaRN.excluir(this.selecionada);
		this.selecionada = new Conta();
		this.lista = null;
	}
	
	
	
	public void tornarFavorita(){
		ContaRN cRn = new ContaRN();
		cRn.tornarFavorita(this.selecionada);
		this.selecionada = new Conta();
	}



	public Conta getSelecionada() {
		return selecionada;
	}



	public void setSelecionada(Conta selecionada) {
		this.selecionada = selecionada;
	}



	public List<Conta> getLista() {
		if(this.lista == null){
			ContextoBean cxtBean = new ContextoBean();
			ContaRN cRn = new ContaRN();
			this.lista = cRn.listar(cxtBean.getUsuarioLogado());
		}
		
		return lista;
	}



	public void setLista(List<Conta> lista) {
		this.lista = lista;
	}
	
	
	
	
	
	
}
